import { Callbag, Source, Sink } from 'callbag'
import { PushEvent } from './baseTypes'
export interface Listener<Type> {
    next: (val: Type) => void
    error: (err: any) => void
    complete: (val?: Type) => void
}
export interface Subscription {
    unsubscribe(): void
}
export interface UseEvent {
    (eventName: string): [Source<void>, () => any]
    <Type = any>(eventName: string, seedValue?: Type): [
        Source<Type>,
        (val: Type) => any
    ]
}
export interface FromEvent {
    (eventName: string): Source<void>
    <Type>(eventName: string, valueTransformer?: (val: any) => Type): Source<
        Type
    >
}
export interface ObservableComponentBase {
    mount: Source<any>
    unmount: Source<any>
    fromEvent: FromEvent
    pushEvent: PushEvent
    useEvent: UseEvent
}
export interface Observe {
    observe: <Type>(
        propName?: string,
        valueTransformer?: (val: any) => Type
    ) => Source<Type>
}
export declare type ObservableComponent = Observe & ObservableComponentBase
export declare type Aperture<Props, Effect, Context = any> = (
    component: ObservableComponent,
    initialProps: Props,
    initialContext?: Context
) => Sink<Effect>
export declare const subscribeToSink: <Type>(
    sink: Callbag<Type, void>,
    next: (val: Type) => void,
    error?: (error: any) => void
) => Subscription
export declare const getObserve: <Props>(
    getProp: any,
    data: any,
    decoratedProps: any
) => <Type>(propName?: any, valueTransformer?: any) => any
export declare const createComponent: <Props>(
    getProp: any,
    dataObservable: any,
    pushEvent: PushEvent,
    decoratedProps: boolean
) => ObservableComponent
export declare const createObservable: (
    subscribe: any
) => {
    [x: string]: any
    subscribe: any
}
