import { ComponentFactory, VNode } from 'preact'
import { Handler, ErrorHandler, PushEvent } from './baseTypes'
import { Aperture } from './observable'
export interface State {
    replace?: boolean
    props: object
    renderEffect: boolean
    children: VNode | null
}
export interface Config<Props, Effect> {
    handler?: Handler<Props, Effect, any>
    errorHandler?: ErrorHandler<Props, any>
    mergeProps?: boolean
    decorateProps?: boolean
}
export declare const withEffects: <Props, Effect, ChildProps = Props>(
    aperture: Aperture<Props, Effect, any>,
    config?: Config<Props, Effect>
) => (
    BaseComponent?: ComponentFactory<
        ChildProps & {
            pushEvent: PushEvent
        }
    >
) => ComponentFactory<Props>
